/* 
 * File:   main.c
 * Author: Pavel
 *
 * Created on 15. ervna 2018, 18:38
 */
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "ltest2.h"
#include "ICbase.h"
#include "text.h"

struct SD {
    char baud1;
    char baud2;
    char hwc1;
    char hwc2;
    char spi1;
    char aux;
    char unch;
    char light;
    char outAB;
    char pw1;
    char pw2;
    char freq1;
    char freq2;
    char freq3;
    char chn;
    char cnt1;
    char cnt2;
    char icname;
    unsigned int output;
    unsigned int direct;
    unsigned int pullup;
    unsigned int inten;
    unsigned int flags;
    unsigned int func;
    signed char etab[8];
};

char str[32];
char rxstr[32] = "?";
char txstr[32];
char Tstr[20]; // = "                  ";
char tempc[20];

char buffer[BFS];
char rptr = 0;
char dsize = 0;
char wptr = 0;
char rxptr = 0;
char txptr = 0;
unsigned int cnt4 = 499, cnt3 = 9, freqc = 9;
char trigs = 0;
char inpchng = 0;
unsigned int cntpa = 0, cntpb = 0;
//char *pins;
unsigned int bit16 = 0;
char bits = 0;
char butinp = 0;
char green = 0;
char red = 0;
//              S9            S10
char tme = 0; //B72 B6 B5 X   B71 B6 B5 X

char disp = 0;
char readf = 0;
char inpint = 0;

unsigned int input = 0x0000;
unsigned int intflg = 0;
unsigned int dilinp = 0;
char volts[20];

char menu = 0;
char chmenu = 0;
char strobe = 0;
char send = 0;
char plsA = 0;
char plsB = 0;
char dled = 0;
char rost = 0;
char reg94 = 0x0B; //Q4 = 1; 5/3 = 0; ra = 1 rb = 1
struct BUTS buts;
struct SD sdt;

char count = 0, tup,binp = 0 ;
char rng=0, /*freq=0,*/ tflg=0;
unsigned tf=0;
unsigned long tmrup;



void interrupt ISR(void) {
    static char breg = 0, togl = 0;
    static char chr = 0, tchr = 0; // lchr = 0;
    
    if (INT0IF) {
        if (sdt.flags & INTE)inpint = 1;
        INT0IF = 0;
    }

    if (INT1IF) {
        readf = 1;
        INT1IF = 0;
       // {TMR1ON=0; TMR1IE = 0; TMR1IF = 0;}
    }

    if (RBIF) {
        if (sdt.flags & (AINT | BINT))
            strobe = (PORTB ^ breg) & 0x30;
        RBIF = 0;
        breg = PORTB & 0x30; //bity RB4 a RB5
    }
    if (RC2IF) {
        // if(FERR2 || OERR2)
        //   PORTEbits.RE0 = 1;
        chr = RCREG2;
        push_char(chr);
    }// RCIF

    if (TX2IF) {

        tchr = txstr[txptr];
        // lchr = txstr[txptr];
        if (tchr == 0x0A || tchr == 0 || txptr > 15) {
            TX2IE = 0;
            TXEN2 = 0;

        } else TXREG2 = tchr;

        txptr++;

    }
    if (TMR4IF) {
        TMR4IF = 0;
        if (cntpa) {
            cntpa--;
            if (cntpa == 0) PORTDbits.RD4 ^= 1;
        }
        if (cntpb) {
            cntpb--;
            if (cntpb == 0) PORTDbits.RD5 ^= 1;
        }
        if (cnt3)cnt3--;
            //if(cnt3==0)
        else {
            cnt3 = freqc;
            PORTAbits.RA6 ^= 1;
        }

        if (cnt4)cnt4--;
        else {
            cnt4 = 499; // 2Hz
            togl ^= 1;
            if (togl)trigs = 1; //1s pro cyklen a teplotu           
        }

        
        if (sdt.func & FREQ) {
            tf++;
            if (tf == 1000)
                tf = 0;
            if (tf == 1) {
                TMR1ON = 1; //otevre Tmr1
             //   TMR1IE = 1;
            } else if (tf == 401) {
                asm("NOP");
                asm("NOP");
                asm("NOP");
                TMR1ON = 0; // zavre Tmr1   
              //  TMR1IE = 0;
              //  TMR1IF = 0;
                tflg = 1;
                //disp=1;
            };
        } //else {TMR1ON=0; TMR1IE = 0; TMR1IF = 0;}

    

    }//if tmr2if

    if (TMR1IF) {
        tup++;
        TMR1IF = 0;
    }
  


}//ISR

void main() {
    T1GCON = 0; T1CON= 0x84; 
    TMR1IE = 0;
    CM1CON = 0;
    CM2CON = 0;
    CMP1IE = 0;
    CMP2IE = 0;
    HLVDIE = 0;
    HLVDCON = 0;
    
    
    OSCCON = 0x70;
    OSCCON2 = 0x00;
    OSCTUNE = 0x40; //PLL    
    REFOCON = 0x00;

    LATE = 0x00;
    LATD = 0x0F;
    LATA = 0x00;
    LATB = 0x00;
    LATC = 0x00;

    TRISE = 0x04;
    TRISA = 0xB0; //RA0- RA3 out, RA7 in, RA5 in
    TRISB = 0xFF;
    TRISC = 0xFF;

    TRISCbits.TRISC0 = 0;
    TRISCbits.TRISC1 = 0;
    TRISCbits.TRISC5 = 0;
    TRISCbits.TRISC3 = 0;
    TRISEbits.TRISE1 = 0; // RE1 out - reset SPI a displ.

    PORTD = 0x0F; //vechny CS do 1
    TRISD = 0x80; //RD6 vstup TX  a RD7 vstup RX


    ANCON0 = 0x80; //AN7 
    ANCON1 = 0;

    ADCON0 = 0x1D; //AN7 - RE2
    ADCON1 = 0x00;
    ADCON2 = 0x3E; //0x24; 
    RBPU = 0; //pull up PORTB 
    WPUB = 0xFF;


    CS0 = 1;
    EN = 0;
    DI = 0;
    SPIOpen();
    Reg94(reg94);
    Delay(100);
    RES = 0; //reset SPI & displ
    Delay(100);
    RES = 1;
    rost = ERead(0x41); // test na restore
    if (rost > 3)rost = 0; //chyba ten eeprom
    if (rost & REOST) {
        if (1 == ReadE())InitPar();
    } else InitPar();

    Attrib(0, STND, XOR, 0, 0, 0, 0, 6, 10, 127);
    Attrib(1, STND, XOR, 0, 0, 0, 0, 6, 10, 60);
    //  Attrib(2, STND, XOR, 0, 0, 0, 0, 6, 10, 64);
    //   Attrib(3, STND, XOR, 0, 0, 0, 0, 6, 10, 127);

    dled = ERead(0x40); //nastaven podsvtlen z EEprom
    if (dled > 32)dled = 20;
    if (POR == 0 && RI == 1) Light(dled); //jen po zapnut
    POR = 1;
    RI = 0;
    SPISend1(0, 0x0A, 0x4C); //IOCON, B=0, M=1, SQR = 0; ADR=1;
    SPISend1(0, 0x0B, 0x4C); // vechny MCP23S17 do mdu s adresou
    SPIInit(Init1);
    SPIInit(Init2);
    SPIInit(Init3);
    //   SPISend1(2, 5, 0x1F); //int pro b0 - b4 - tltka
    //   SPISend1(3, 5, 0x1F); //int pro b0 - b4 - tlatka

    green = 0x00;
    red = 0x00;
    tme = 0x20;
    LEDS(green, red, tme);

    Delay(100);

    //---------------------- TMR3 -------------------------------
    /*
    SOSCEN3 = 1;
    T3CKPS0 = 1;
    T3CKPS1 = 1;
    TMR3CS0=0;
    TMR3CS1 = 0;
    TMR3ON = 1;
    TMR3GE = 0;
     */

    //------------------- TMR4 --------------------------
    //if(freq) 
 //  {T1GCON = 0; T1CON= 0x84; }   //init TMR1 


    T4CON = 0x4B; //post 10, pre 16
    PR4 = 99; // 1 kHz
    TMR4ON = 1;
    TMR4IE = 1;

    OpenUART(2); //pipojen k adaptru USB

    IPEN = 0;
    INT0IF = 0;
    INT1IF = 0;
    INT1IE = 1;
    INT0IE = 1;
    INTEDG1 = 0;
    PEIE = 1;

    IOCB = 0x00; //  bit 7 je RB7, bit 6 RB6, bit 5 RB5, bit 4 RB4  - interrupty RB4 - RB7
    
  

    
    RBIE = 1;
    GIE = 1;

    PORTAbits.RA6 = 0;

    SPISend1(2, 5, 0x1F); //int pro b0 - b4 - tltka
    SPISend1(3, 5, 0x1F); //int pro b0 - b4 - tlatka

    init_2(); //grafick md

    GbufFill(0x0); //vynuluje RAM pro displej
    GbufToLCD(); //mae displ.
    Text(34, 10, 12, 10, text2[0], BIG | COL1); //Logic
    Text(26, 30, 12, 10, text2[1], BIG | COL1); //Tester
    GbufToLCD();
    Delay(2000);
    GbufFill(0x0);
    GbufToLCD(); //mae displ.


    chmenu = 1; //vstup do menu
    disp = 1; //zobrazen 
    //------------------------ hlavn smyka -------------------------------
    while (1) {
        // if(RC2IF || FERR2 || OERR2)PORTEbits.RE0 = 1; 

        if (inpint) { //test na interrupt ze vstup A0 a B7
            disp = 1;
            inpint = 0;
            inpchng = 1;
            intflg = SPIRead2(1, 0x0E); //nate, na kterm vstupu byla zmna
        }
        if (trigs) { //test na interrupt od asovae 1 Hz
            trigs = 0;
            if (sdt.spi1 == 1) {
                Temp(); //je-li pip. TC77, nate teplotu
                if (menu == 4)disp = 1; //je-li oteveno menu 4, zobraz teplotu
            }
            if ((sdt.flags & CYKL)&& (menu == 0)) { //v menu 0 cyklick natn vstup
                disp = 1;
                tme |= 0x40; //blikne erv. vpravo
            }
        }//trigs
        if(tflg){
            tflg = 0;
            if(menu == 4 && sdt.func == FREQ){
                FreqCnt();
        Rect2(4, 106, 33, 10, COL0);        
        Text(4, 33, 6, 10, text4[11], COL1);
        TextA(NX,NY,str);
        GbufToLCD();        
            }
            
        }

        if (strobe) {
            // Delay(1); // ppadn potlaen zkmit na vstupech
            if (menu < 20) disp = 1;
            if (menu < 3) {
                if ((strobe & 0x10) && (sdt.flags & AINT)) { //test na interrupt vstup SA
                    tme |= 2; // blikne zel. LED vlevo (menu))
                    if (sdt.flags & ATRAP)Line(16, 20, 51, 51, 2); //pastika vlevo
                }

                if ((strobe & 0x20)&& (sdt.flags & BINT)) { //test na interrupt vstup SB
                    tme |= 0x40; // blikne erv. LED vpravo (enter))            
                    if (sdt.flags & BTRAP)Line(108, 112, 51, 51, 2); //pastika vpravo                  
                }
                if (sdt.flags & TRAPS)Sound(12, 150); //je-li povoleno ppnut
            }//menu<3
            LEDS(green, red, tme);
            strobe = 0;
        }//if strobe

        if (readf) {
            Delay(50); //potlaen zkmit tlatek
            buts = ReadButs(); //nate stav tlatek
            if (buts.b2 & 1) { //tla. vlevo vol menu s vbrem 
                tme |= 0x04;
                if (menu >= 20)menu++;
                if (menu < 20 || menu > 21)
                    menu = 20;
                chmenu = 1;
            } //else tme &= ~0x04;
            if (buts.b2 & 2) { //tla. vpravo posouv kurzor v menu nebo vypne pstroj
                chmenu = 1;
                tme |= 0x40;
                if (menu == 0) {
                    sdt.etab[0]++;
                    if (sdt.etab[0] > 2)sdt.etab[0] = 0;
                } else if (menu == 1) {
                    sdt.etab[1]++;
                    if (sdt.etab[1] > 3)sdt.etab[1] = 0;
                } else if (menu == 2) {
                    sdt.etab[2]++;
                    if (sdt.etab[2] > 4)sdt.etab[2] = 0;
                } else if (menu == 3) {
                    sdt.etab[3]++;
                    if (sdt.etab[3] > 7)sdt.etab[3] = 0;
                } else if (menu == 7) {
                    sdt.etab[7] ^= 0x40;
                    //  if (sdt.etab[7] > 1)sdt.etab[7] = 0;   

                } else if (menu == 20)Poff();

            } else {
                tme &= ~0x40;
                LEDS(green, red, tme);
            }
            if (buts.b8 != 0) disp = 1;
            readf = 0;
        }

        USBrw(); //USB r w je-li v bufferu znak z USB, zpracuje ho

        if (chmenu) { //zkladn nastaven plochy
            GbufFill(0x0); //smazat gbuf
            Bord1(0, 127, 0, 63, XOR | 1); //tl = 1, 2, 3, 4=dvojit rmeek
            Rect2(2, 11, 53, 9, COL1 | CORN); //oznaen tla. menu
            Char8(5, 54, 'M', XOR);
            Rect2(116, 10, 53, 9, COL1 | CORN);
            Char8d(118, 54, 0xDC, XOR); //oznarn tla. enter
            green = red = 0;
            if (menu >= 20) {
                MeHelp(0); //zobrazen nabdky
                Text(16, 54, 13, 10, tlac[menu - 18], XOR | BOLD); //popis tlatek 
                if (sdt.flags & MENSN)Sound(20, 100);

                //------------------ menu 0 ----------------------------
            } else if (menu == 0) {
                char tb;
                Bord2(117, 9, 17, 11, COL1 | 1);
                Char8d(119, 19, 'P', XOR); //menu    

                Rect2(116, 10, 53, 9, COL1 | CORN);
                Char8d(118, 54, 0xDC, XOR); //znak enter

                if (sdt.etab[0] < 2) {
                    Rect2(117, 9, 2, 9, COL1);
                    Char8d(119, 3, 0xCB, XOR | BOLD); //ipka  
                }

                if (sdt.etab[0] == 0) {
                    green = butinp = *((char *) &sdt.output + 1);
                    Line(64, 110, 11, 11, 1);
                    tb = 0;
                } else if (sdt.etab[0] == 1) {
                    green = butinp = sdt.output;
                    Line(16, 62, 11, 11, 1);
                    tb = 1;
                } else if (sdt.etab[0] == 2) {
                    green = butinp = sdt.outAB;
                    Line(24, 28, 51, 51, 1);
                    Line(100, 104, 51, 51, 1);
                    Rect2(116, 10, 42, 9, COL1);
                    Rect2(2, 10, 42, 9, COL1);
                    tb = 8;
                }

                Char8d(4, 43, 'A', XOR | BOLD);
                Char8d(118, 43, 'B', XOR | BOLD);

                LEDS(green, 0, tme);

                Text(15, 54, 13, 10, tlac[tb], XOR | BOLD);

                //------pullup----------------                             
                Spullup(); //nastav smr vstup / vstup a rezist. pullup
                Flags(0, 0); //jen nastv podle flags
                //--------vstupy------------ 
                Char8(4, 3, 'O', XOR | BOLD);
                Output(3, 1);

                //-------vstupy--------------
                Char8(4, 13, 'I', XOR | BOLD);
                Input(13);

                //--------napt-------------
                Char8(4, 27, 'U', XOR | BOLD);
                Levels(23, sdt.unch); //grafickz napt na vstupech
                //a seln napt na zvolenm vstupu
                //--------VDD----------------
                VDD(115, 33); //indikace napjen 5V nebo 3.3V
            }//menu 0 

                //--------------- menu 1 -------------------------
            else if (menu == 1) {
                char ys = 2, ts = 0;
                Bord2(117, 9, 17, 11, COL1 | 1);
                Char8d(119, 19, 'H', XOR); //menu   

                if (sdt.etab[1] == 0) {
                    green = butinp = *((char *) &sdt.output + 1);
                    Line(64, 110, 11, 11, 1);
                    ts = 0;
                    ys = 2;
                } else if (sdt.etab[1] == 1) {
                    green = butinp = sdt.output;
                    Line(16, 62, 11, 11, 1);
                    ts = 1;
                    ys = 2;
                } else if (sdt.etab[1] == 3) {
                    Rect2(116, 10, 53, 9, COL1 | CORN);
                    Char8d(118, 54, 0xDC, XOR); //znak enter
                    ts = 7;
                    ys = 53;
                } else if (sdt.etab[1] == 2) {
                    green = butinp = sdt.outAB;
                    Line(24, 28, 51, 51, 1);
                    Line(100, 104, 51, 51, 1);
                    Rect2(116, 10, 42, 9, COL1);
                    Rect2(2, 10, 42, 9, COL1);
                    ts = 8;
                    ys = 43;
                }
                Char8d(4, 43, 'A', XOR | BOLD);
                Char8d(118, 43, 'B', XOR | BOLD);
                LEDS(green, red, tme);

                if (sdt.etab[1] < 2) {
                    Rect2(117, 9, ys, 9, COL1);
                    Char8d(119, ys + 1, 0xCB, XOR | BOLD); //ipka 
                    Rect2(116, 10, 53, 9, COL1 | CORN);
                    Char8d(118, 54, 0xDC, XOR); //znak enter
                }
                Text(15, 54, 13, 10, tlac[ts], XOR | BOLD);

                //------pullup----------------                               
                Spullup();
                //--------vstupy------------ 
                Char8(4, 3, 'O', XOR | BOLD);
                Output(3, send);
                //-------vstupy--------------
                Char8(4, 13, 'I', XOR | BOLD);
                Input(13);
                //--------napt-------------
                Char8(4, 27, 'U', XOR | BOLD);
                Levels(23, sdt.unch);
                Flags(0, 0); //jen bity
                //--------VDD----------------
                VDD(115, 33);
            }//menu 1 

                //-------------------- menu 2 ----------------------------
            else if (menu == 2) {
                red = green = 0;
                Bord2(117, 9, 22, 11, COL1 | 1);
                Char8d(119, 24, 'T', XOR); //menu   
                Rect2(116, 10, 53, 9, COL1 | CORN);
                Char8d(118, 54, 0xDC, XOR); //znak enter

                if (sdt.etab[2] == 0) {
                    butinp = green = *((char *) &sdt.output + 1);
                    Line(64, 110, 11, 11, 1);
                } else if (sdt.etab[2] == 1) {
                    butinp = green = sdt.output;
                    Line(16, 62, 11, 11, 1);
                } else if (sdt.etab[2] == 2) {
                    butinp = red = *((char *) &sdt.direct + 1);
                    Line(64, 110, 21, 21, 1);
                } else if (sdt.etab[2] == 3) {
                    butinp = red = sdt.direct;
                    Line(16, 62, 21, 21, 1);
                } else if (sdt.etab[2] == 4) {
                    green = butinp = sdt.outAB;
                    Line(24, 28, 51, 51, 1);
                    Line(100, 104, 51, 51, 1);
                    Rect2(116, 10, 42, 9, COL1);
                    Rect2(2, 10, 42, 9, COL1);
                }

                LEDS(green, red, tme);

                if (sdt.etab[2] < 2) {
                    Rect2(117, 9, 2, 9, COL1);
                    Char8d(119, 3, 0xCB, XOR | BOLD); //ipka   
                } else if (sdt.etab[2] < 4) {
                    Rect2(117, 9, 12, 9, COL1);
                    Char8d(119, 13, 0xCB, XOR | BOLD); //ipka  
                }
                Char8d(4, 43, 'A', XOR | BOLD);
                Char8d(118, 43, 'B', XOR | BOLD);
                //------pullup----------------                               
                Spullup();
                //-------direct--------------
                Char8(4, 13, 'D', XOR | BOLD);
                Direct(13);

                //--------vstupy------------ 
                Char8(4, 3, 'O', XOR | BOLD);
                Output(3, 1);

                //-------vstupy--------------
                Char8(4, 23, 'I', XOR | BOLD);
                Input(23);
                //--------napt-------------
                //   Char8(4, 27, 'U', XOR | BOLD);
                //   Levels(23, sdt.unch);
                Flags(0, 0); //jen bity
                //--------VDD----------------
                VDD(115, 34);

                if (sdt.etab[2] < 4)bits = sdt.etab[2] & 1;
                else bits = 9;
                Text(15, 54, 13, 10, tlac[bits], XOR | BOLD); //popis tlatek

                //-------------------- menu 3 -------------------------
            } else if (menu == 3) {
                char x;
                char y;
                unsigned int tmp;
                Rect2(116, 10, 53, 9, COL1 | CORN);
                Char8d(118, 54, 0xDC, XOR); //znak enter

                switch (sdt.etab[3] & 0x0E) {
                    case 0: y = 11;
                        tmp = sdt.direct;
                        break;
                    case 2: y = 21;
                        tmp = sdt.pullup;
                        break;
                    case 4: y = 31;
                        tmp = sdt.inten;
                        break;
                    case 6: y = 41;
                        tmp = sdt.flags;
                        break;
                }//switch
                strcpy(str, tlac[5 + (sdt.etab[3] & 1)]);
                for (char i = 0; i < 8; i++)str[i] &= 0xDF; //strupr
                if (sdt.etab[3] >= 6)Text(16, 54, 13, 10, str, XOR | BOLD);
                else Text(15, 54, 13, 10, tlac[sdt.etab[3] & 1], XOR | BOLD); //popis tlatek

                if (sdt.etab[3] & 1) {
                    red = butinp = tmp;
                    x = 16;
                } else {
                    red = butinp = *((char *) &tmp + 1);
                    x = 64;
                }
                LEDS(0, red, tme);
                if (sdt.etab[3] < 7) Line(x, x + 46, y, y, 1);
                else Line(16, 16 + 46, y, y, 1);
                Rect2(117, 9, y - 9, 9, COL1);
                Char8d(119, y - 8, 0xCB, XOR | BOLD); //ipka 

                Char8(4, 3, 'D', XOR | BOLD);
                Direct(3);
                Char8(4, 13, 'P', XOR | BOLD);
                Pullup(13);
                Char8(4, 23, 'E', XOR | BOLD);
                Inter(23);
                Char8(4, 33, 'F', XOR | BOLD);
                Flags(33, 1);
                VDD(115, 43);

            }//------------------- menu 4 ------------------------------          
            else if (menu == 4) {

                Text(16, 54, 13, 10, tlac[12], XOR | BOLD);
                Text(40, 3, 7, 10, menutext[0][4], COL1 | BOLD);
                green = 0;
                red = sdt.func;
                LEDS(green, red, tme);

                Funct();
            }// menu 4
                //----------------------- menu 5 --------------------
            else if (menu == 5) {
                //Puls
                // Char8(4, 3, menutext[0][5][0], COL1 | BOLD);
                Text(40, 3, 7, 10, menutext[0][5], COL1 | BOLD); //nadpis Pulsy
                THelp(0);

                for (char i = 0; i < 8; i++)
                    Puls(i);
                Text(16, 54, 13, 10, tlac[10], XOR | BOLD); //popis tlatek
                Puls(sdt.etab[5]);
                Flags(0, 0);
            }// menu 5
                //---------------------- menu 6 ----------------------
            else if (menu == 6) {
                // "Systm"

                //  Char8(4, 3, (menutext[0][6][0]), COL1 | BOLD);
                Text(40, 3, 7, 10, menutext[0][6], COL1 | BOLD); //nadpis Systm

                THelp(1);

                for (char i = 0; i < 8; i++)
                    Syst(i);
                Text(16, 54, 13, 10, tlac[10], XOR | BOLD); //popis tlatek
                Syst(sdt.etab[6]);
                Flags(0, 0);
            }//menu 6
            else if (menu == 7) {
                //-------------------- menu 7 ---------------------    
                //test IC obvod

                if (!(sdt.etab[7] & 0x40)) {
                    //  Char8(4, 3, (menutext[0][7][0]), COL1 | BOLD);
                    Text(40, 3, 7, 10, menutext[0][7], COL1 | BOLD); //nadpis Systm
                    THelp(2);

                    Text(16, 54, 13, 10, tlac[11], XOR | BOLD); //popis tlatek   
                    for (char i = 0; i < 7; i++) {
                        ICpar(i);
                        ICpar(sdt.etab[7] & 0x07);
                        Flags(0, 0);
                    }
                } else {
                    //  dilinp = 0;
                    Dil(0, dilinp, ICname[sdt.icname], sdt.flags); //zobraz DIL  
                    green = dilinp;
                    LEDS(green, 0, tme);
                }
            }//menu 7

            disp = 0;
            GbufToLCD();
            chmenu = 0;
        }//if chmenu
        //---------------------- disp -----------------------------
        if (disp) {
            if (menu >= 20) {
                // if(buts.b2 & )
                switch (buts.b8) { //vbr dle tlatek
                    case 1: menu = 0; //L                   
                        break;
                    case 2: menu = 1; //S                    
                        break;
                    case 4: menu = 2; //T                
                        break;
                    case 8: menu = 3; //Dir + Pul + Int 
                        break;
                    case 0x10: menu = 4; //Funkce
                        break;
                    case 0x20: menu = 5; //Pulsy
                        break;
                    case 0x40: menu = 6; //System
                        break;
                    case 0x80: menu = 7; //IC DIL
                        break;
                }//switch
                LEDS(buts.b8, 0, tme);
                tme &= ~0x04;
                chmenu = 1;
            }//menu 20

            else { //menu 0 a 7
                //----------------------- menu 0 --------------------------
                if (menu == 0) {
                    red = green = 0;
                    butinp ^= buts.b8; //tla. 1 - 8
                    green = butinp;
                    LEDS(green, red, tme);

                    if (sdt.etab[0] == 1) *((char *) &sdt.output) = butinp;
                    else if (sdt.etab[0] == 0)(*((char *) &sdt.output + 1)) = butinp;
                    else if (sdt.etab[0] == 2) {
                        sdt.outAB = (butinp &= 0x42);
                        if (buts.b8 & 0x10) {
                            sdt.unch++; //oznaen menho vstupu ->
                            if (sdt.unch > 15)sdt.unch = 0;
                        }
                        if (buts.b8 & 0x08) {
                            if (sdt.unch > 0)sdt.unch--; //oznaen menho vstupu <-
                            else sdt.unch = 15;
                        }
                        green &= 0x42;
                    }
                    //--------------smr in/out & pullup-----------------                    
                    Spullup();
                    //-------------vstupy--------------------
                    Output(3, 1);
                    //-----------------vstupy -----------------   
                    Input(13);
                    //-----------------napt------------------
                    Levels(23, sdt.unch);
                }//menu 0

                    //----------------------------- menu 1 --------------------------
                else if (menu == 1) { //hradlovan vstup
                    red = green = 0;
                    butinp ^= buts.b8; //tla. 1 - 8
                    green = butinp;
                    LEDS(green, 0, tme);

                    if (sdt.etab[1] == 1) *((char *) &sdt.output) = butinp;
                    else if (sdt.etab[1] == 0)(*((char *) &sdt.output + 1)) = butinp;
                    else if (sdt.etab[1] == 2) {
                        sdt.outAB = (butinp &= 0x42);
                        if (buts.b8 & 0x10) {
                            sdt.unch++;
                            if (sdt.unch > 15)sdt.unch = 0;
                        }
                        if (buts.b8 & 0x08) {
                            if (sdt.unch > 0)sdt.unch--;
                            else sdt.unch = 15;
                        }
                        green &= 0x42;
                    } else {
                        green = buts.b8;
                        LEDS(green, 0, tme);
                        if (buts.b8 & 0x20)send = 1;
                        if (buts.b8 & 0x02)plsA = 1;
                        if (buts.b8 & 0x01) {
                            send = 1;
                            plsA = 1;
                        }
                        if (buts.b8 & 0x40)plsB = 1;
                        if (buts.b8 & 0x80) {
                            send = 1;
                            plsB = 1;
                        }
                        green = 0;
                    }
                    //-------------- pullup-----------------                  
                    Spullup();
                    //-------------vstupy--------------------
                    Output(3, send); //vstup a na synchro
                    send = 0;

                    if (plsA) {
                        PORTDbits.RD4 ^= 1; //zmna vstupu OA a start timeru
                        cntpa = tconst[sdt.pw1];
                        plsA = 0;
                    }
                    if (plsB) {
                        PORTDbits.RD5 ^= 1;
                        cntpb = tconst[sdt.pw2]; //zmna vstupu OB a start timeru
                        plsB = 0;
                    }
                    //-----------------vstupy -----------------   
                    Input(13);
                    //-----------------napt------------------
                    Levels(23, sdt.unch);
                }//menu 1

                    //----------------------- menu 2 ---------------------------
                else if (menu == 2) { //vstup s monost OC nebo tstav.
                    green = red = 0;
                    butinp ^= buts.b8; //tla. 1 - 8                   

                    if (sdt.etab[2] == 0) {
                        *((char *) &sdt.output + 1) = butinp;
                        green = butinp;
                    } else if (sdt.etab[2] == 1) {
                        *((char *) &sdt.output) = butinp;
                        green = butinp;
                    } else if (sdt.etab[2] == 2) {
                        *((char *) &sdt.direct + 1) = butinp;
                        red = butinp;
                    } else if (sdt.etab[2] == 3) {
                        *((char *) &sdt.direct) = butinp;
                        red = butinp;
                    } else if (sdt.etab[2] == 4) {
                        sdt.outAB = butinp & 0x42;

                        green = butinp;
                    }
                    LEDS(green, red, tme);

                    //--------------smr in/out & pullup-----------------
                    Direct(13);
                    Spullup();
                    //-------------vstupy--------------------
                    Output(3, 1);
                    //-----------------vstupy -----------------   
                    Input(23);

                    //------------------------ menu 3 -------------------------
                } else if (menu == 3) { //nastavem smru, pullup, flags, interrupt
                    red = green = 0;
                    butinp ^= buts.b8; //tla. 1 - 8 
                    red = butinp;
                    LEDS(green, red, tme);

                    switch (sdt.etab[3]) {
                        case 0: *((char *) &sdt.direct + 1) = butinp;
                            break;
                        case 1: *((char *) &sdt.direct) = butinp;
                            break;
                        case 2: *((char *) &sdt.pullup + 1) = butinp;
                            break;
                        case 3: *((char *) &sdt.pullup) = butinp;
                            break;
                        case 4: *((char *) &sdt.inten + 1) = butinp;
                            break;
                        case 5: *((char *) &sdt.inten) = butinp;
                            break;
                        case 6: *((char *) &sdt.flags + 1) = butinp;
                            intflg = 0;
                            break;
                        case 7: *((char *) &sdt.flags) = butinp;
                            intflg = 0;
                            break;
                    }//switch

                    Direct(3);
                    Pullup(13);
                    Inter(23);
                    Flags(33, 1);
                    Rect2(115, 12, 43, 8, COL0);
                    VDD(115, 43);
                    //menu 3
                    //-------------------------- menu 4 ----------------------------    
                } else if (menu == 4) { //zobrazen pomocnch funkc, teplota, test RAM

                    red = green = 0;
                    sdt.func ^= buts.b8; //tla. 1 - 8 
                    red = sdt.func;
                    LEDS(green, red, tme);

                    Funct();

                    //------------------------ menu 5 -------------------------   
                } else if (menu == 5) { //nastaven frekvenc a puls
                    green = buts.b8;
                    LEDS(green, red, tme);
                    if (buts.b8 & 0x20) {
                        sdt.etab[5]++;
                        if (sdt.etab[5] > 7)sdt.etab[5] = 0;
                    }
                    if (buts.b8 & 0x04) {
                        sdt.etab[5]--;
                        if (sdt.etab[5] < 0)sdt.etab[5] = 7;
                    }
                    if (buts.b8 & 0x80) {
                        if (1 == ReadE())InitPar(); //obnoven nastaven z EEprom
                        chmenu = 1;
                    }
                    if (buts.b8 & 1) {
                        SaveE(); //zpis nastaven do EEprom
                    }
                    Puls(sdt.etab[5]);
                    Delay(200);
                    green = 0;
                    //------------------------- menu 6 ---------------------
                } else if (menu == 6) { //systmov nastaven
                    green = buts.b8;
                    LEDS(green, red, tme);
                    if (buts.b8 & 0x20) {
                        sdt.etab[6]++;
                        if (sdt.etab[6] > 7)sdt.etab[6] = 0;
                    }
                    if (buts.b8 & 0x04) {
                        sdt.etab[6]--;
                        if (sdt.etab[6] < 0)sdt.etab[6] = 7;
                    }
                    if (buts.b8 & 0x80) {
                        if (1 == ReadE())InitPar();
                        chmenu = 1;
                    }
                    if (buts.b8 & 1) {
                        SaveE();
                    }
                    Syst(sdt.etab[6]);
                    Delay(200);
                    green = 0;
                    Flags(0, 0);
                }//menu 6
                    //------------------------ menu 7 ---------------------------
                else if (menu == 7) { //test IC DIL
                    if (!(sdt.etab[7] & 0x40)) {
                        green = buts.b8;
                        LEDS(green, red, tme);

                        if (buts.b8 & 0x20) {
                            sdt.etab[7]++;
                            if ((sdt.etab[7]& 0x07) > 7)sdt.etab[7] &= ~0x07;
                        }
                        if (buts.b8 & 0x04) {
                            if (sdt.etab[7] == 0)sdt.etab[7] | = 7;
                            if ((sdt.etab[7] & 0x07) > 0)sdt.etab[7]--;
                        }
                        ICpar(sdt.etab[7] & 0x07);
                        Flags(0, 0);
                        Delay(200);
                        green = 0;
                    }//if
                    else {
                        dilinp ^= buts.b8;
                        green = dilinp;
                        LEDS(green, 0, tme);
                        Dil(1, dilinp, ICname[sdt.icname], sdt.flags); //zmny v DIL
                    }
                }//menu 7
            }//menu < 20
            GbufToLCD();
            if ((sdt.flags & (AINT | BINT | CYKL)) || menu == 5) {
                tme &= ~0x40;
                tme &= ~0x02; //zhasne zel, menu led
                LEDS(green, red, tme);
            }
            disp = 0;
        }//if disp
    }//while
}//main 
//--------------------------------- END OF MAIN ---------------------------


//------------------------------- Pulsy a frekvence ---------------------------

char *GetICPins(char x) {
    return ICpins[x];
}//

void ICpar(char in) {
    static char x = 4, y = 13, *pt;
    static char vcc = 0;
    char len = (sizeof (ICname) / 16) - 1;
    if (!chmenu) Line(x, x + 56, y + 8, y + 8, COL0);
    switch (in) {
        case 0:
            if (buts.b8 & 0x10) {
                if (sdt.icname < len) sdt.icname++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.icname > 0) sdt.icname--;
            }
            pt = ICname[sdt.icname];
            x = 4;
            y = 13;
            break;
        case 1:
            if (buts.b8 & 0x10) {
                sdt.unch++;
                if (sdt.unch > 15)sdt.unch = 0;
            }
            if (buts.b8 & 0x08) {
                if (sdt.unch == 0)sdt.unch = 15;
                sdt.unch--;
            }
            x = 66;
            y = 13;
            pt = itoa(str, sdt.unch + 1, 10);
            break;

        case 2:
            if (buts.b8 & 0x10) {
                sdt.flags |= V53;
            }
            if (buts.b8 & 0x08) {
                sdt.flags &= ~V53;
            }
            x = 4;
            y = 23;
            pt = text4[sdt.flags & V53 ? 4 : 6];
            break;
        case 3:
            if (buts.b8 & 0x10) {
                sdt.flags |= VDDIC;
            }
            if (buts.b8 & 0x08) {
                sdt.flags &= ~VDDIC;
            }
            pt = text4[sdt.flags & VDDIC ? 2 : 3];
            x = 66;
            y = 23;
            break;
        case 4:
            if (buts.b8 & 0x10) {
                sdt.flags | = PULE;
            }
            if (buts.b8 & 0x08) {
                sdt.flags & = ~PULE;
            }
            x = 4;
            y = 33;
            pt = text4[sdt.flags & PULE ? 2 : 3];
            break;
        case 5:
            x = 66;
            y = 33;
            pt = " ";
            break;
        case 6:
            if (buts.b8 & 0x10) {
                sdt.flags | = OUTE;
            }
            if (buts.b8 & 0x08) {
                sdt.flags & = ~OUTE;
            }
            x = 4;
            y = 43;
            pt = text4[sdt.flags & OUTE ? 2 : 3];
            break;
        case 7:
            x = 66;
            y = 43;
            pt = " ";
            break;
    }//switch
    // Rect2(40, 32, y, 10, COL0);
    // Text(40, y, 6, 10, pt, COL1);

    Rect2(x + 22, 35, y, 10, COL0);
    Text(x + 22, y, 6, 10, pt, COL1);
    if (in == (sdt.etab[7] & 0x07)) Line(x, x + 56, y + 8, y + 8, COL1);


}//

void Puls(char sw) {
    static char x = 4, y = 13, *pt;
    if (!chmenu) Line(x, x + 56, y + 8, y + 8, COL0);
    switch (sw) {
        case 0: x = 4;
            y = 13;
            if (buts.b8 & 0x10) {
                if (sdt.pw1 < 7) sdt.pw1++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.pw1 > 0) sdt.pw1--;
            }
            pt = PWText[sdt.pw1];
            break;
        case 1: x = 66;
            y = 13;
            if (buts.b8 & 0x10) {
                if (sdt.pw2 < 7) sdt.pw2++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.pw2 > 0) sdt.pw2--;
            }
            pt = PWText[sdt.pw2];
            break;
        case 2: x = 4;
            y = 23;
            if (buts.b8 & 0x10) {
                if (sdt.freq1 < 5) sdt.freq1++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.freq1 > 0) sdt.freq1--;
            }

            pt = FreqText[sdt.freq1];
            break;
        case 3: x = 66;
            y = 23;
            if (buts.b8 & 0x10) {
                if (sdt.freq2 < 5) sdt.freq2++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.freq2 > 0) sdt.freq2--;
            }
            pt = FreqText[sdt.freq2];
            break;
        case 4: x = 4;
            y = 33;
            if (buts.b8 & 0x10) {
                if (sdt.cnt1 < 25) sdt.cnt1++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.cnt1 > 0) sdt.cnt1--;
            }
            str[0] = ' ';
            itoa(str + 1, sdt.cnt1, 10); //PWText[sdt.pw1];
            pt = str;
            break;
        case 5: x = 66;
            y = 33;
            if (buts.b8 & 0x10) {
                if (sdt.cnt2 < 25) sdt.cnt2++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.cnt2 > 0) sdt.cnt2--;
            }
            str[0] = ' ';
            itoa(str + 1, sdt.cnt2, 10); //PWText[sdt.pw2];
            pt = str;
            break;
        case 6: x = 4;
            y = 43;
            if (buts.b8 & 0x10) {
                if (sdt.freq3 < 9) sdt.freq3++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.freq3 > 0) sdt.freq3--;
            }
            pt = FreqCText[sdt.freq3];
            freqc = freqcTab[sdt.freq3];
            cnt3 = 1; //vnut novou konst.
            break;
        case 7: x = 66;
            y = 43;
            if (buts.b8 & 0x10) {
                if (sdt.chn < 3) sdt.chn++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.chn > 0) sdt.chn--;
            }
            pt = CHNText[sdt.chn];
            break;
    }//switch
    Rect2(x + 22, 35, y, 10, COL0);
    Text(x + 22, y, 6, 10, pt, COL1);
    if (sw == sdt.etab[5]) Line(x, x + 56, y + 8, y + 8, COL1);
}//

//------------------------ Systmov nastaven -----------------------

void Syst(char sw) {
    static char x = 4, y = 13, *pt;
    //  char len = sizeof(ICname)/10 -1;
    if (!chmenu) Line(x, x + 56, y + 8, y + 8, COL0);

    switch (sw) {

        case 0: x = 4;
            y = 13;
            if (buts.b8 & 0x10) {
                if (sdt.baud1 < 8) sdt.baud1++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.baud1 > 0) sdt.baud1--;
            }
            BaudSet(1);
            pt = BaudText[sdt.baud1];
            break;
        case 1: x = 66;
            y = 13;
            if (buts.b8 & 0x10) {
                if (sdt.baud2 < 8) sdt.baud2++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.baud2 > 0) sdt.baud2--;
            }
            pt = BaudText[sdt.baud2];
            BaudSet(2);
            break;
        case 2: x = 4;
            y = 23;
            if (buts.b8 & 0x10) {
                if (sdt.hwc1 < 5) sdt.hwc1++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.hwc1 > 0) sdt.hwc1--;
            }

            pt = HWCText1[sdt.hwc1];
            break;
        case 3: x = 66;
            y = 23;
            if (buts.b8 & 0x10) {
                if (sdt.hwc2 < 5) sdt.hwc2++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.hwc2 > 0) sdt.hwc2--;
            }
            pt = HWCText2[sdt.hwc2];
            break;
        case 4: x = 4;
            y = 33;
            if (buts.b8 & 0x10) {
                if (rost < 3)rost++;
                else rost = 0;

            }
            if (buts.b8 & 0x08) {
                if (rost > 0)rost--;
                else rost = 3;

            }
            pt = SRText[rost];
            EWrite(0x41, rost);

            break;
        case 5: x = 66;
            y = 33;
            if (buts.b8 & 0x10) {
                if (dled < 32) dled++;
            }
            if (buts.b8 & 0x08) {
                if (dled > 0) dled--;
            }

            pt = itoa(str, dled, 10);
            break;
        case 6: x = 4;
            y = 43;
            if (buts.b8 & 0x10) {
                if (sdt.spi1 < 3) sdt.spi1++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.spi1 > 0) sdt.spi1--;
            }
            pt = SPIText[sdt.spi1];
            break;
        case 7: x = 66;
            y = 43;
            if (buts.b8 & 0x10) {
                if (sdt.aux < 3) sdt.aux++;
            }
            if (buts.b8 & 0x08) {
                if (sdt.aux > 0) sdt.aux--;
            }
            pt = AUXText[sdt.aux];
            break;
    }//switch
    Rect2(x + 22, 35, y, 10, COL0);
    Text(x + 22, y, 6, 10, pt, COL1);
    if (sw == sdt.etab[6]) Line(x, x + 56, y + 8, y + 8, COL1);
}//

//--------------------------- Zpis do registru 4094 - IC7 -------------------

void Reg94(char reg) {
    char dm;
    CS94 = 0;
    SSPBUF = reg;
    while (!SSPIF);
    dm = SSPBUF;
    SSPIF = 0;
    CS94 = 1;
}

//---------------------- Nastaven flag -------------------------------

void Flags(char y, char echo) {
    if (echo) {
        bit16 = 0x0001;
        strcpy(Tstr, tlac[6]);
        strcat(Tstr, tlac[5]);
        for (char i = 0; i < 16; i++) {
            if (i == 0) {
                {
                    if (sdt.flags & bit16) Tstr[i] = '5';
                    else Tstr[i] = '3';
                }
            } else if (sdt.flags & bit16)
                Tstr[i] &= ~0x20;
            bit16 <<= 1;
        }
        Rect2(16, 97, y, 8, COL0); //smae vstupy   
        Text(16, y, 6, 10, Tstr, COL1);
    }
    //  {"rtabtric"}, //5
    if (sdt.flags & AINT)IOCB4 = 1;
    else IOCB4 = 0; // SA - KB0
    if (sdt.flags & BINT)IOCB5 = 1;
    else IOCB5 = 0; // SB - KB1
    if (sdt.flags & V53)reg94 |= 0x04;
    else reg94 & = ~0x04; // 1=5V 0=3.3V
    if (sdt.flags & RESA)reg94 &= ~0x01;
    else reg94 |= 0x01; //rezistor A
    if (sdt.flags & RESB)reg94 &= ~0x02;
    else reg94 |= 0x02; //rezistor B

    Reg94(reg94);
}

//------------------------------ Naten vstup ----------------------------

void Input(char y) {
    char x = 16;

    input = SPIRead2(1, 0x12);

    Rect2(16, 97, y, 10, COL0); //smae vstupy 
    bit16 = 0x0001;
    y += 8;
    for (char i = 0; i < 16; i++) {
        if (input & bit16)Tstr[i] = '1';
        else Tstr[i] = '0';

        if (intflg & bit16) Line(x, x + 4, y, y, 2);

        bit16 <<= 1;
        x += 6;
    }//for 
    if ((inpchng) && (sdt.flags & INTSN))Sound(15, 100);
    inpchng = 0;

    Text(16, y - 8, 6, 10, Tstr, XOR); //vstupy

    Rect2(16, 8, 43, 8, COL0);
    Rect2(108, 8, 43, 8, COL0);
    if (PORTBbits.RB4)bits = '1';
    else bits = '0';
    Char8d(16, 43, bits, COL1);
    if (PORTBbits.RB5) {
        bits = '1';
    } else {
        bits = '0';
    }
    Char8d(108, 43, bits, COL1);

}//

//---------------------------- Men napt na vstupech -------------------

void Levels(char y, char un) {
    char z, x;

    Rect2(16, 97, y, 11, COL0); //smae vstupy 
    y += 10;
    x = 16;
    reg94 &= 0x0F; //od 0

    Rect2(16, 97, y + 2, 4, COL0); //mae oznaen Ch
    SPISend2(1, 0x04, 0); //zake int.

    // Reg94(reg94);
    reg94 &= 0x0F; //adresa mpx od nuly
    for (char i = 0; i < 16; i++) {
        // SPISend2(1, 0x04, 0); //zake int.    
        Reg94(reg94);
        reg94 += 0x10;
        Udelay(1); //10us
        GO = 1; // start AD pevodnku -------
        while (GO);
        //  
        volts[i] = ADRESH;
        if (ADRESL & 0x0F) volts[i] = 0;


        for (z = y; z > y - (volts[i] / 25); z--)
            Line(x, x + 4, z, z, COL1);
        if (i == un)Line(x, x + 4, y + 3, y + 3, 3 | COL1);
        x += 6;
    }//for 
    SPISend2(1, 0x04, sdt.inten); //povol int.

    Rect2(34, 61, 41, 11, COL1 | CORN); //mae linku pro grafy napt

    utoa(Tstr + 1, un, 10);
    Tstr[0] = 'U';
    Text(38, 43, 6, 10, Tstr, XOR);
    Text(60, 43, 6, 10, Volts(volts[un]), XOR);
    Char8d(86, 43, 'V', XOR);

}//


//------------------ Vstupy ------------------------------

void Output(char y, char send) {
    bit16 = 0x0001;
    for (char i = 0; i < 16; i++) {
        if (sdt.direct & bit16) Tstr[i] = '.';
        else if (sdt.output & bit16)Tstr[i] = '1';
        else Tstr[i] = '0';
        bit16 <<= 1;
    }//for  

    if (send) SPISend2(1, 0x12, sdt.output);
    if (sdt.outAB & 0x02)PORTDbits.RD4 = 1;
    else PORTDbits.RD4 = 0;
    if (sdt.outAB & 0x40)PORTDbits.RD5 = 1;
    else PORTDbits.RD5 = 0;
    Rect2(16, 97, y, 8, COL0); //smae vstupy           
    Text(16, y, 6, 10, Tstr, COL1); //vstupy
    Rect2(24, 8, 43, 8, COL0);
    Rect2(100, 8, 43, 8, COL0);
    if (PORTDbits.RD4)bits = '1';
    else bits = '0';
    Char8d(24, 43, bits, COL1);
    if (PORTDbits.RD5)bits = '1';
    else bits = '0';
    Char8d(100, 43, bits, COL1);
}//

//--------------------------- Smr vstup / vstup -------------------

void Direct(char y) {

    bit16 = 0x0001;
    for (char i = 0; i < 16; i++) {
        if ((sdt.direct & bit16) && (sdt.pullup & bit16))Tstr[i] = 'p';
        else if (sdt.direct & bit16)Tstr[i] = 'i';

        else Tstr[i] = 'o';
        bit16 <<= 1;
    }//for 
    SPISend2(1, 0x0, sdt.direct);
    Rect2(16, 97, y, 8, COL0); //smae in/out 
    Text(16, y, 6, 10, Tstr, XOR); //smr in/out
}//

//------------------------ Nastaven dmru a pullup bez vpisu -------------

void Spullup() {
    SPISend2(1, 0x0C, sdt.pullup);
    SPISend2(1, 0x0, sdt.direct);
}//

//-------------------- Nastaven pullup a zobrazen ------------------------

void Pullup(char y) { //slouit s dir

    bit16 = 0x0001;
    for (char i = 0; i < 16; i++) {
        if (sdt.pullup & bit16)Tstr[i] = 'p';
        else Tstr[i] = '.';
        bit16 <<= 1;
    }//for 
    SPISend2(1, 0x0C, sdt.pullup);
    Rect2(16, 97, y, 8, COL0); //smae sdt.pullup 
    Text(16, y, 6, 10, Tstr, XOR); //sdt.pullup
}//

//----------------------- Nastaven povolench interrupt ----------------------

void Inter(char y) { //slouit s dir

    bit16 = 0x0001;
    for (char i = 0; i < 16; i++) {
        if (sdt.inten & bit16)Tstr[i] = 'e';
        else Tstr[i] = '.';
        bit16 <<= 1;
    }//for 
    SPISend2(1, 0x04, sdt.inten);
    Rect2(16, 97, y, 8, COL0); //smae sdt.pullup 
    Text(16, y, 6, 10, Tstr, XOR); //sdt.pullup
}//

//---------------------- Naten teploty z TC77 -------------------------

unsigned SPIr2() {
    unsigned tem = 0; //0x0C87; //25

    CSSPI = 0;
    SSPBUF = 0;
    while (!SSPIF);
    SSPIF = 0;
    *((char *) &tem + 1) = SSPBUF;
    SSPBUF = 0;
    while (!SSPIF);
    SSPIF = 0;
    tem |= SSPBUF;
    CSSPI = 1;
    return tem;
}

void Temp() { //nacteni teploty z TC77
    unsigned tem = 0; //0x0C87; //25
    /*
        CSSPI = 0;
        SSPBUF = 0;
        while (!SSPIF);
        SSPIF = 0;
     *((char *) &tem + 1) = SSPBUF;
        SSPBUF = 0;
        while (!SSPIF);
        SSPIF = 0;
        tem |= SSPBUF;
        CSSPI = 1;
     */
    tem = SPIr2();
    utoa(str, (tem >> 3)*5 / 8, 10);

    tempc[0] = str[0]; //jen do 99 st
    tempc[1] = str[1];
    tempc[2] = '.';
    tempc[3] = str[2];
    tempc[4] = ''; //0xF8;
    tempc[5] = 'C';
    tempc[6] = 0x20;
    tempc[7] = 0;
}//

//----------------- Vysln veliiny int pes USB nebo UART ------------------

void Sendu(char uart, char zn, unsigned val) {
    if (uart == 2)
        TXEN2 = 0;
    else TXEN1 = 0;
    txstr[0] = zn;
    strcpy(txstr + 1, "=0x");
    utoa(txstr + 4, val, 16);
    strcat(txstr, " \n");
    txptr = 0;
    if (uart == 2) {
        TX2IE = 1;
        TXEN2 = 1;
    } else {
        TX1IE = 1;
        TXEN1 = 1;
    }
}//

//----------------- Vysln veliiny char pes USB nebo UART ------------------

void Sendb(char uart, char zn, char val) {

    if (uart == 2)
        TXEN2 = 0;
    else TXEN1 = 0;
    txstr[0] = zn;
    txstr[1] = '=';

    if (val)txstr[2] = '1';
    else txstr[2] = '0';
    txstr[3] = 0;
    strcat(txstr, " \n");
    txptr = 0;
    if (uart == 2) {
        TX2IE = 1;
        TXEN2 = 1;
    } else {
        TX1IE = 1;
        TXEN1 = 1;
    }
}//

//-------------------------- Pjem a vysln pes USB -----------------------

void USBrw() {
    char pchr;

    unsigned int val = 0;
    if (!(rptr == wptr && dsize == 0)) {
        pchr = pull_char();

        rxstr[rxptr] = pchr;
        rxptr++;
        if (rxptr > 16 || pchr == 0 || pchr == 0x0A || pchr == 0x0D) {
            rxstr[rxptr] = 0;
            rxptr = 0;
            if (rxstr[1] == '?') {
                switch (rxstr[0] & 0xDF) { //velk i mal
                    case 'A':
                        Sendb(2, 'A', PORTBbits.RB4);
                        break;
                    case 'B':
                        Sendb(2, 'B', PORTBbits.RB5);
                        break;
                    case 'I':
                        Sendu(2, 'I', input);
                        break;
                    case 'E':
                        Sendu(2, 'E', sdt.inten);
                        break;
                    case 'F':
                        Sendu(2, 'F', sdt.flags);
                        break;
                    case 'O':
                        Sendu(2, 'O', sdt.output);
                        break;
                    case 'P':
                        Sendu(2, 'P', sdt.pullup);
                        break;
                    case 'D':
                        Sendu(2, 'D', sdt.direct);
                        break;
                    case 'U':
                        txptr = 0;
                        txstr[0] = 0;
                        strcpy(txstr, "U=0x");
                        TXEN2 = 0;
                        utoa(&txstr[4], volts[sdt.unch], 16);
                        strcat(txstr, " 0x");
                        utoa(str, sdt.unch & 0x0F, 16);
                        strcat(txstr, str);
                        strcat(txstr, " \n");
                        txptr = 0;
                        TX2IE = 1;
                        TXEN2 = 1;
                        break;

                    case 'R': asm("reset");
                        break;
                    case 'V':
                        Poff();
                        //  menu = 7;
                        //  chmenu = 1;
                        break;

                }//switch    
            }//if
            else
                if (rxstr[1] == '=') {
                val = strtol(rxstr + 2, NULL, 0);
                switch (rxstr[0] & 0xDF) { //velk i mal

                    case 'O':
                        sdt.output = val;
                        break;
                    case 'D':
                        sdt.direct = val;
                        break;
                    case 'P':
                        sdt.pullup = val;
                        break;
                    case 'E':
                        sdt.inten = val;
                        break;
                    case 'F':
                        sdt.flags = val;
                        break;

                    case 'A':
                        if (val)sdt.outAB |= 0x02;
                        else sdt.outAB &= ~0x02;
                        break;
                    case 'B':
                        if (val)sdt.outAB |= 0x40;
                        else sdt.outAB &= ~0x40;
                        break;
                    case 'U':
                        sdt.unch = val & 0x0F;
                        break;
                }//switch
            }//if =

            else if (rxstr[2] == '=') {

                val = strtol(rxstr + 3, NULL, 0);
                /*
                if(rxstr[1] & 0xDF)=='O'){
                   switch (rxstr[0]& 0xDF ){
                       case 'A':
                           
                       break;    
                   } 
                }//if */
                switch (rxstr[0] & 0xDF) {
                    case 'O':
                        if (rxstr[1] == '1')sdt.output |= val;
                        else sdt.output &= ~val;
                        break;
                    case 'D':
                        if (rxstr[1] == '1')sdt.direct |= val;
                        else sdt.direct &= ~val;
                        break;
                    case 'P':
                        if (rxstr[1] == '1')sdt.pullup |= val;
                        else sdt.pullup &= ~val;
                        break;
                    case 'E':
                        if (rxstr[1] == '1')sdt.inten |= val;
                        else sdt.inten &= ~val;
                        break;
                    case 'F':
                        if (rxstr[1] == '1')sdt.flags |= val;
                        else sdt.flags &= ~val;
                        break;
                }
            }

            //  disp = 1;
            chmenu = 1;
        }
    }
}//USBrw

//----------------------- ten z EEprom s kontrolnm soutem ---------------

char ReadE() {
    char adr = 0;
    unsigned int rcs = 0;
    unsigned int cs = 0;
    char len = sizeof (sdt);
    char *ept;
    ept = (char *) &sdt;
    //len;
    for (char i = 0; i < len; i++) {
        *ept = ERead(adr);
        cs += *ept;
        ept++;
        adr++;
    }
    rcs = ERead(adr);
    adr++;
    *((char *) &rcs + 1) = ERead(adr);
    if (cs != rcs)return 1;
    return 0;
}//

//----------------------- Zpis do EEprom s kontrolnm soutem ---------------

void SaveE() {
    char adr = 0;
    unsigned int cs = 0;
    char len = sizeof (sdt);
    char *ept;
    ept = (char *) &sdt;
    //len ++;

    for (char i = 0; i < len; i++) {
        EWrite(adr, *ept);
        cs += *ept;
        ept++;
        adr++;
    }
    EWrite(adr, cs); //kontroln souet
    adr++;
    EWrite(adr, *((char*) &cs + 1));
}//

//---------------------------- Vypnut s avzem ----------------------

void Poff() {
    if (rost & SAOEX) SaveE();

    EWrite(0x40, dled);
    Rect2(35, 58, 15, 28, COL0);
    Bord2(36, 56, 16, 26, COL1 | 1);
    Text(43, 22, 12, 10, "BYE!", BIG | COL1);
    Rect2(38, 52, 18, 22, XOR);

    GbufToLCD();
    if (sdt.flags & MENSN)Sound(25, 150);
    Delay(2000);

    tme |= 0x08; //B71
    LEDS(green, red, tme);
}//

//

void push_char(char c) {
    wptr++;
    wptr &= (BFS - 1);
    buffer[wptr] = c;
    dsize++;
}//

/*
char buffer_full(void) {
    return rptr == wptr && dsize == BFS;
}

char buffer_empty(void) {
    return rptr == wptr && dsize == 0;
}
 */


char pull_char(void) {
    rptr++;
    rptr &= (BFS - 1);
    dsize--;
    return buffer[rptr];
}//

void InitPar() {
    memset((char *) &sdt, 0, sizeof (sdt)); //vynuluje struct. sdt
    sdt.baud1 = sdt.baud2 = 4;
    sdt.direct = sdt.pullup = 0x00FF; //
    sdt.pw1 = sdt.pw2 = 3;
    sdt.freq3 = 7;
    freqc = freqcTab[7];
    cnt3 = 1;
    dled = 20;
    sdt.icname = 0;
    sdt.chn = 3; //outc na RA6
    sdt.hwc2 = 1; //USB
    sdt.func = 0;
}//

void BaudSet(char uart) {
    if (uart == 2) {
        SPBRG2 = Baud[sdt.baud2 << 1];
        SPBRGH2 = Baud[(sdt.baud2 << 1) + 1];
    } else {
        SPBRG1 = Baud[sdt.baud1 << 1];
        SPBRGH1 = Baud[(sdt.baud1 << 1) + 1];
    }
}//

void OpenUART(char uart) {
    if (uart == 2) {
        SPEN2 = 1;
        SYNC2 = 0;
        SREN2 = 0;
        CREN2 = 1;
        TXEN2 = 1;
        BRGH2 = 1;
        BRG162 = 1;
        BaudSet(2); //5 = 19200, 4 = 9600
        RC2IE = 1;
    } else {
        SPEN1 = 1;
        SYNC1 = 0;
        SREN1 = 0;
        CREN1 = 1;
        TXEN1 = 1;
        BRGH1 = 1;
        BRG161 = 1;
        BaudSet(1); //5 = 19200, 4 = 9600
        RC1IE = 1;
    }
}//

void Light(char in) {
    //  Reg94(reg94 & 0xF7); //Q4 = 0
    Reg94(0x00);
    Udelay(1);
    for (char i = 0; i < in; i++) {
        SSPBUF = 0x00;
        while (!SSPIF);
        bits = SSPBUF;
        SSPIF = 0;

        SSPBUF = 0xFF;
        while (!SSPIF);
        bits = SSPBUF;
        SSPIF = 0;
    }
    SSPBUF = 0x00;
    while (!SSPIF);
    bits = SSPBUF;
    SSPIF = 0;
    Reg94(0x0B); //Q4 = 1
    // Reg94(reg94);
}//

void VDD(char x, char y) {
    if (sdt.flags & V53) Text(x, y, 6, 10, text4[4], XOR);
    else {
        if (menu != 7)Text(x, y, 6, 10, text4[5], XOR);
        else Text(x - 12, y, 6, 10, text4[6], XOR);
    }
}//

void MeHelp(char mn) {

    char x = 4;
    char y = 3;
    for (char i = 0; i < 8; i++) {
        Char8(x, y, menutext[mn][i][0], COL1 | BOLD);
        Text(x + 7, y, 6, 10, menutext[mn][i] + 1, COL1);
        if (i == 3) {
            x = 74;
            y = 3;
        } else y += 10;
    }//for

    Char8(118, 43, 0xEB, XOR | BOLD); //ipka
    if (rost & SAOEX) Text(44, 43, 6, 10, text4[1], COL1);
    else Text(81, 43, 6, 10, text4[0], COL1);

}//MeHelp

void THelp(char tn) {
    char x = 4;
    char y = 13;
    for (char i = 0; i < 8; i++) {
        Text(x, y, 6, 10, text3[tn][i], COL1);
        if (i == 3) {
            x = 66;
            y = 13;
        } else y += 10;
    }
}//

void Sound(char per, unsigned int ts) {
    tme |= 0x80; //B72 on
    LEDS(green, red, tme);
    while (ts) {
        PORTAbits.RA0 ^= 1;
        Udelay(per);
        ts--;
    }
    tme &= ~0x80; //B72 off
    LEDS(green, red, tme);
}//

void MpxAdr(char un) {
    Reg94((reg94 & 0xFF) | un << 4); //adresa mpx
}//

char GetUn() {
    return sdt.unch;
}//

void Funct() {
    unsigned val = 0;
    Rect2(4, 106, 13, 10, COL0);
    Rect2(4, 106, 23, 10, COL0);
    Rect2(4, 106, 33, 10, COL0);
    Rect2(4, 106, 43, 10, COL0);
 if(sdt.func & FREQ) TMR1IE = 1; else {TMR1IE=0; TMR1ON = 0;}

    if (sdt.spi1 == 2 && sdt.func & SPI) {

        Text(4, 13, 6, 10, text4[9], COL1);
        //send SPI
    }
    if (sdt.spi1 == 3 && sdt.func & SPI) {

        Text(4, 13, 6, 10, text4[10], COL1);
        val = SPIr2;
        utoa(str + 2, val, 16);
        str[0] = '0';
        str[1] = 'x';
        TextA(NX, NY, str);
    }
    if (sdt.spi1 == 1 && sdt.func & TEMP) {

        Text(4, 23, 6, 10, text4[7], COL1);
        TextA(NX, NY, tempc);
    }
    if (sdt.func & FREQ) {
        // Rect2(4, 106, 33, 10, COL0);
      //  FreqCnt();
      //  Text(4, 33, 6, 10, text4[11], COL1);
      //  TextA(NX,NY,str);
        //freq. counter
    }
    else if (sdt.func & 8) {
        //  Rect2(4, 106, 33, 10, COL0);
        Text(4, 33, 6, 10, text4[12], COL1);
        //pulse counter
    }


    if (sdt.func & 0x80) {
        //  Rect2(4, 106, 43, 10, COL0);
        Text(4, 43, 6, 10, text4[8], COL1);
        strcpy(str, text4[13]); //test RAM IC12 23LCV1024 
        Ramrw(0, 0x100, str, 9); //zpis 9 znak do RAM od sdr. 0x100    
        Ramrw(1, 0x100, str, 9); //test ten z RAM
        TextA(NX, NY, str);
    }
}//


void FreqCnt() {

    unsigned long tml, tmh;
    char len = 0; //row;
    char frac = '0';

    tml = TMR1L;
    tmh = TMR1H;
    tmrup = tup;

    tml += ((tmh << 8) + (tmrup << 16));
    TMR1L = TMR1H = tup = 0;
    TMR1IF = 0;

    ultoa(str, tml >> 2, 10);

    while (str[len] != 0)len++;

  //  if ((char) tml & 2)frac = '5';

    if (len > 2) {
        str[len] = str[len - 1];
        str[len - 1] = str[len - 2];
        str[len - 2] = str[len - 3];

        if (len > 5) {
            str[len - 3] = str[len - 4];
            str[len - 4] = str[len - 5];
            str[len - 5] = '.';
            len -= 3;
            str[len + 3] = 'M';
        }//if len>5
        else {
            str[len - 2 ] = '.';
            str[len + 3] = 'k';
          //  str[len + 1] = frac;
        }
        str[len + 2] = 0x20;
        strcpy(&str[len + 4], text4[14]);

    }//if len>2
    else {
        if (tml > 0) {
            str[len] = frac;
        }//if tml
        else len--;
        str[len + 1] = 0x20;
        strcpy(&str[len + 2], text4[14]); //Hz
    }

    len = 0;
    while (str[len] != 0)len++;
    while ((len) < 15) {
        str[len] = 0x20;
        len++;
    }

    str[15] = 0;
    str[16] = 0;
   /* if(freq<5){
        switch(freq){            
            case 2: row = ROW2;
            break;
            case 3: row = ROW3;
            break;
            case 4: row = ROW4;
            break;
            default: row = ROW1;
        }
        }*/
   // LCD_Chr(row, CMD);
   // LCD_Strx(str2);
    
    }
/*
T1CONbits.TMR1ON = 0; //Stop timer from incrementing
PIE1bits.TMR1IE = 0; //Temporarily disable Timer1 interrupt vectoring
TMR1H = 0x00; //Update timer value
TMR1L = 0x00;
T1CONbits.TMR1ON = 1; //Turn on timer
//Now wait at least two full T1CKI periods + 2TCY before re-enabling Timer1 interrupts.
//Depending upon clock edge timing relative to TMR1H/TMR1L firmware write operation,
//a spurious TMR1IF flag event may sometimes assert. If this happens, to suppress
//the actual interrupt vectoring, the TMR1IE bit should be kept clear until
//after the "window of opportunity" (for the spurious interrupt flag event has passed).
//After the window is passed, no further spurious interrupts occur, at least
//until the next timer write (or mode switch/enable event).
while(TMR1L < 0x02); //Wait for 2 timer increments more than the Updated Timer
//value (indicating more than 2 full T1CKI clock periods elapsed)
NOP(); //Wait two more instruction cycles
NOP();
PIR1bits.TMR1IF = 0; //Clear TMR1IF flag, in case it was spuriously set
PIE1bits.TMR1IE = 1; //Now re-enable interrupt vectoring for timer 1
*/ 
